: drop ] drop ;
: dup ] dup ;

: [ ;
: ( [ $ 0029 l ] word ] drop ;

( constants )
: 0 [ $ 0000 l ;;
: 1 [ $ 0001 l ;;
: 2 [ $ 0002 l ;;
: 4 [ $ 0004 l ;;
: -1 [ $ ffff l ;;

( variables )
: var c : ] here ] l c ; ] 2 ] allot ;

( math )
macro : 1+ [ $ 9601 l ] i, ;
: 1+ ] 1+ ;
macro : 1- [ $ 9701 l ] i, ;
: 1- ] 1- ;

: * ] m* ] drop ;
macro : 2* [ $ 0f88 l ] i, [ $ 1f99 l ] i, ;
macro : 2/ [ $ 9595 l ] i, [ $ 9587 l ] i, ;

macro : invert [ $ 9580 l ] i, [ $ 9590 l ] i, ;

: negate ] invert ] 1+ ;

( conditionals )
macro : ? [ $ 9600 l ] i, ;
: if [ $ f001 l ] i, ] ihere ] 1- ;
: -if [ $ f402 l ] i, ] ihere ] 1- ;

: then ] ihere ] over ] - ] 1-
  [ $ 007f l ] and ] 2* ] 2* ] 2*
  ] over ] i@ ] or ] swap ] i! ;

: jump
  [ $ 91ff i, ( pop zh )
  [ $ 91ef i, ( pop zl )
    ( 2* )
    [ $ 0f88 i, ( lsl tosl )
    [ $ 1f99 i, ( rol tosh )
  [ $ 0fe8 i, ( add zl,tosl )
  [ $ 1ff9 i, ( adc zh,tosh )
    ( drop )
    [ $ 9189 i, ( ld tosl,y+ )
    [ $ 9199 i, ( ld tosh,y+ )
  [ $ 9409 i, ( ijmp )

: 0= if ] 0 ; then ] -1 ;
: = ] xor ] 0= ;

: cell+ ] 2 ] + ;

( double operators )
: d@ ] dup ] cell+ ] @ ] swap ] @ ;
: d! ] swap ] over ] ! ] cell+ ] ! ;
: d1- ] swap ] dup if ] 1- ] swap ; then ] 1- ] swap ] 1- ;
: d1+ ] swap ] 1+ ] dup if ] swap ; then ] swap ] 1+ ;
: d0= ] 0= if ] 0= if [ $ ffff l ; then then [ $ 0000 l ;

: low [ $ 00ff l ] and ;
: high ] >< ] low ;

( interrupts )
: vec ] dup ] >r ] - ] 1-
  [ $ 0fff l ] and [ $ c000 l ] or
  ] r> ] i! ;
macro : inton [ $ 9478 l ] i, ;
macro : intoff [ $ 94f8 l ] i, ;

( multitasking )
: taskinit ( task ds rs xt -- )
  ] >< ] over ] 2 ] - ] !
  ] swap ] 2 ] - ] >< ] over ] 4 ] - ] !
  [ $ 5 l ] - ] swap ] ! ;
: taskqueue ( task -- )
  ] me ] 2 ] + ] @
  ] over ] 2 ] + ] !
  ] me ] 2 ] + ] ! ;
: wait ( reg mask -- )
  ] over ] c@ ] over ] and ] ? if
    ] drop ] swap ] c! ;
  then ] drop ] pause ] wait ;

( i/o registers )
: pind [ $ 30 l ;
: ddrd [ $ 31 l ;
: portd [ $ 32 l ;
: pinc [ $ 33 l ;
: ddrc [ $ 34 l ;
: portc [ $ 35 l ;
: pinb [ $ 36 l ;
: ddrb [ $ 37 l ;
: portb [ $ 38 l ;
: pina [ $ 39 l ;
: ddra [ $ 3a l ;
: porta [ $ 3b l ;

mark

