;;; atmega128 defines

.include "rampz.asm"
.equ iosize = $e0
.equ ramsize = $1000
.equ flashsize = $10000
.equ eepromsize = $1000
.equ pagesize = $80
.equ nrww = $f000
    
.equ UBRR0L = $29

.equ UCSR0B = $2a
  .equ RXCIE = 7
  .equ TXCIE = 6
  .equ UDRIE = 5
  .equ RXEN = 4
  .equ TXEN = 3
  .equ UCSZ2 = 2
  .equ RXB8 = 1
  .equ TXB8 = 0

.equ UCSR0A = $2b
  .equ RXC = 7
  .equ TXC = 6
  .equ UDRE = 5
  .equ FE = 4
  .equ DOR = 3
  .equ PE = 2
  .equ U2X = 1
  .equ MPCM = 0

.equ UDR0 = $2c

.equ EECR = $3c
  .equ EERIE = 3
  .equ EEMWE = 2
  .equ EEWE = 1
  .equ EERE = 0
.equ EEDR = $3d
.equ EEARL = $3e
.equ EEARH = $3f
        
.equ RAMPZ = $5b
  .equ RAMPZ0 = 0

.equ TIFR = $56
  .equ OCF2 = 7
  .equ TOV2 = 6
  .equ ICF1 = 5
  .equ OCF1A = 4
  .equ OCF1B = 3
  .equ TOV1 = 2
  .equ OCF0 = 1
  .equ TOV0 = 0

.equ SPMCSR = $68
  .equ SPMIE = 7
  .equ RWWSB = 6
  .equ RWWSRE = 4
  .equ BLBSET = 3
  .equ PGWRT = 2
  .equ PGERS = 1
  .equ SPMEN = 0

.equ UBRR0H = $90

