;;; atmega8 defines

.include "norampz.asm"
.equ iosize = $40
.equ ramsize = $400
.equ flashsize = $1000
.equ eepromsize = $200
.equ pagesize = 32

    
.equ UBRRL = $29
.equ UBRR0L = UBRRL

.equ UCSRB = $2a
.equ UCSR0B = UCSRB
  .equ RXCIE = 7
  .equ TXCIE = 6
  .equ UDRIE = 5
  .equ RXEN = 4
  .equ TXEN = 3
  .equ UCSZ2 = 2
  .equ RXB8 = 1
  .equ TXB8 = 0

.equ UCSRA = $2b
.equ UCSR0A = UCSRA
  .equ RXC = 7
  .equ TXC = 6
  .equ UDRE = 5
  .equ FE = 4
  .equ DOR = 3
  .equ PE = 2
  .equ U2X = 1
  .equ MPCM = 0

.equ UDR = $2c  
.equ UDR0 = UDR

.equ EECR = $3c
  .equ EERIE = 3
  .equ EEMWE = 2
  .equ EEWE = 1
  .equ EERE = 0
.equ EEDR = $3d
.equ EEARL = $3e
.equ EEARH = $3f

.equ UBRRH = $40
.equ UBRR0H = UBRRH

.equ TCCR0 = $53
  .equ CS02 = 2
  .equ CS01 = 1
  .equ CS00 = 0

.equ SPMCR = $57
.equ SPMCSR = SPMCR
  .equ SPMIE = 7
  .equ RWWSB = 6
  .equ RWWSRE = 4
  .equ BLBSET = 3
  .equ PGWRT = 2
  .equ PGERS = 1
  .equ SPMEN = 0

.equ TIFR = $58
  .equ OCF2 = 7
  .equ TOV2 = 6
  .equ ICF1 = 5
  .equ OCF1A = 4
  .equ OCF1B = 3
  .equ TOV1 = 2
  .equ TOV0 = 0

.equ TIMSK = $59
  .equ OCIE2 = 7
  .equ TOIE2 = 6
  .equ TICIE1 = 5
  .equ OCIE1A = 4
  .equ OCIE1B = 3
  .equ TOIE1 = 2
  .equ TOIE0 = 0

