;;; numeric input


;; 10*
;;
;; ( x1 -- x2 )

link_
.db "10*",0

tenstar:
  twostar_
  twostar_
  twostar_
  twostar_
  ret


;; $
;;
;; ( -- x )

link_
.db "$",0

dollar:
  rcall bl
  rcall word
  adiw tos,0
  brne dollar_good_word
  rjmp dollar_err
  
dollar_good_word:
  movw z,tos
  movw tos,zero

dollar_get_char:
  ld temp0,z+
  tst temp0
  brne dollar_good_char
  rjmp dollar_done

dollar_good_char:
  rcall tenstar

dollar_test_0:
  cpi temp0,'0'
  brne dollar_test_1
  ori tosl,$00
  rjmp dollar_get_char

dollar_test_1:
  cpi temp0,'1'
  brne dollar_test_2
  ori tosl,$01
  rjmp dollar_get_char

dollar_test_2:
  cpi temp0,'2'
  brne dollar_test_3
  ori tosl,$02
  rjmp dollar_get_char

dollar_test_3:
  cpi temp0,'3'
  brne dollar_test_4
  ori tosl,$03
  rjmp dollar_get_char

dollar_test_4:
  cpi temp0,'4'
  brne dollar_test_5
  ori tosl,$04
  rjmp dollar_get_char

dollar_test_5:
  cpi temp0,'5'
  brne dollar_test_6
  ori tosl,$05
  rjmp dollar_get_char

dollar_test_6:
  cpi temp0,'6'
  brne dollar_test_7
  ori tosl,$06
  rjmp dollar_get_char

dollar_test_7:
  cpi temp0,'7'
  brne dollar_test_8
  ori tosl,$07
  rjmp dollar_get_char

dollar_test_8:
  cpi temp0,'8'
  brne dollar_test_9
  ori tosl,$08
  rjmp dollar_get_char

dollar_test_9:
  cpi temp0,'9'
  brne dollar_test_a
  ori tosl,$09
  rjmp dollar_get_char

dollar_test_a:
  cpi temp0,'a'
  brne dollar_test_b
  ori tosl,$0a
  rjmp dollar_get_char

dollar_test_b:
  cpi temp0,'b'
  brne dollar_test_c
  ori tosl,$0b
  rjmp dollar_get_char

dollar_test_c:
  cpi temp0,'c'
  brne dollar_test_d
  ori tosl,$0c
  rjmp dollar_get_char

dollar_test_d:
  cpi temp0,'d'
  brne dollar_test_e
  ori tosl,$0d
  rjmp dollar_get_char

dollar_test_e:
  cpi temp0,'e'
  brne dollar_test_f
  ori tosl,$0e
  rjmp dollar_get_char

dollar_test_f:
  cpi temp0,'f'
  brne dollar_no_match
  ori tosl,$0f
  rjmp dollar_get_char

dollar_no_match:
  rjmp dollar_get_char
  
dollar_err:
  drop_

dollar_done:
  ret

