;; um*
;;
;; ( u1 u2 -- ud )
;;
;; unsigned 16*16->32 multiply

link_
.db "um*",0

umstar:
  ld xl,y+
  ld xh,y+

  ; tosh * xh
  mul tosh,xh
  movw temp2,r0

  ; tosl * xl
  mul tosl,xl
  movw temp0,r0

  ; tosh * xl
  mul tosh,xl
  add temp1,r0
  adc temp2,r1
  adc temp3,zero

  ; xh * tosl
  mul xh,tosl
  add temp1,r0
  adc temp2,r1
  adc temp3,zero

  ; put low cell on stack
  st -y,temp1
  st -y,temp0

  ; high cell is above low cell on stack
  movw tos,temp2
  ret

