;; word
;;
;; ( char -- c-addr | 0 )

link_
.db "word",0,0

word:
  rcall source
  rcall fetch
  rcall wordbuf
;  rcall fetch
  movw x,tos
  drop_
  movw z,tos
  drop_

  ; skip past opening delimeters
word_find_start:
  ld temp0,z+

  tst temp0
  breq word_not_found

  cp tosl,temp0
  breq word_find_start

  sbiw z,1

word_find_end:
  ld temp0,z+
  st x+,temp0

  tst temp0
  breq word_eol
  
  cp tosl,temp0
  brne word_find_end

word_found:
  ; replace delimeter with null
  st -x,zero
  adiw x,1
  rjmp word_address

word_eol:
  sbiw z,1

word_address:
  movw tosl,zl
  rcall source
  rcall store

  rcall wordbuf
  ret

word_not_found:
  ; store new source
  movw tosl,zl
  rcall source
  rcall store

  dup_
  movw tosl,zero
  ret

