;;; atmega32 defines

.include "norampz.asm"
.equ iosize = $40
.equ ramsize = $800
.equ flashsize = $4000
.equ eepromsize = $400
.equ pagesize = 64
.equ nrww = $3800

.equ UBRRL = $29
.equ UBRR0L = UBRRL

.equ UCSRB = $2a
.equ UCSR0B = UCSRB
  .equ RXCIE = 7
  .equ TXCIE = 6
  .equ UDRIE = 5
  .equ RXEN = 4
  .equ TXEN = 3
  .equ UCSZ2 = 2
  .equ RXB8 = 1
  .equ TXB8 = 0

.equ UCSRA = $2b
.equ UCSR0A = UCSRA
  .equ RXC = 7
  .equ TXC = 6
  .equ UDRE = 5
  .equ FE = 4
  .equ DOR = 3
  .equ PE = 2
  .equ U2X = 1
  .equ MPCM = 0

.equ UDR = $2c  
.equ UDR0 = UDR

.equ EECR = $3c
  .equ EERIE = 3
  .equ EEMWE = 2
  .equ EEWE = 1
  .equ EERE = 0
.equ EEDR = $3d
.equ EEARL = $3e
.equ EEARH = $3f
        
.equ UBRRH = $40
.equ UBRR0H = UBRRH

.equ SPMCR = $57
.equ SPMCSR = SPMCR
  .equ SPMIE = 7
  .equ RWWSB = 6
  .equ RWWSRE = 4
  .equ BLBSET = 3
  .equ PGWRT = 2
  .equ PGERS = 1
  .equ SPMEN = 0

