;; accept
;;
;; ( c-addr u -- c-addr )
;;
;; in: buffer address and length
;; out: address of asciiz string

link_
.db "accept",0,0

accept:
  rcall over
  rcall plus
  oneminus_
  rcall over

accept_getkey:
  rcall key

  cpi tosl,$0d
  breq accept_gotcr

  ; ignore line feeds
  cpi tosl,$0a
  brne accept_echo
  drop_
  rjmp accept_getkey

accept_echo:
  dup_
  rcall emit

  cpi tosl,$08
  breq accept_gotbs

; normal key
  rcall over
  rcall cstore
  oneplus_
  rcall over
  rcall umin
  rjmp accept_getkey

; backspace
accept_gotbs:
  drop_
  oneminus_
  rcall tor
  rcall over
  rcall rfrom
  rcall umax
  rjmp accept_getkey

; end of line
accept_gotcr:
  ; null byte
  drop_lit_ $0000
  rcall over
  rcall cstore
  drop_
  drop_

;  rcall nip
;  rcall over
;  rcall minus
  ret

