;; find
;;
;; ( c-addr addr -- c-addr false | xt true )

link_
.db "find",0,0

find:
  rcall over
  rcall over

  ; name starts at offset 1 in header
  plus__ 1

find_get_chars:
  rcall over
  rcall fetch
  rcall over
  rcall ifetch

find_check_chars:
  rcall over
  rcall over
  rcall cequal
  adiw tos,0
  drop_
  breq find_mismatch

  tst tosl
  breq find_found
  
  rcall over
  rcall swapbytes
  rcall over
  rcall swapbytes
  rcall cequal
  adiw tos,0
  drop_
  breq find_mismatch

  tst tosh
  breq find_found

  drop_
  drop_

  plus__ 1
  rcall swapp

  plus__ 2
  rcall swapp

  rjmp find_get_chars
  
find_found:
  drop_
  drop_
  plus__ 1
  rcall tor
  drop_
  drop_
  drop_
  rcall rfrom
  rcall true
  ret

find_mismatch:
  drop_
  drop_
  drop_
  drop_
  rcall ifetch

  adiw tos,0
  breq find_not_found

  rjmp find

find_not_found:
  ; tos already equals zero
  ret

