;; m*
;;
;; ( n1 n2 -- d )
;;
;; signed 16*16->32 multiply

link_
.db "m*",0,0

; accumulator is tosh:tosl:xh:xl
; multiplier and multiplicand are in
; temp3:temp2 and temp1:temp0 because
; of register restrictions with mulsu

mstar:
  ld temp0,y+
  ld temp1,y+
  movw temp2,tos

  ; temp3 * temp1
  muls temp3,temp1
  movw tos,r0

  ; temp2 * temp0
  mul temp2,temp0
  movw x,r0

  ; temp3 * temp0
  mulsu temp3,temp0
  sbc tosh,zero
  add xh,r0
  adc tosl,r1
  adc tosh,zero

  ; temp1 * temp2
  mulsu temp1,temp2
  sbc tosh,zero
  add xh,r0
  adc tosl,r1
  adc tosh,zero

  ; put low cell on stack
  st -y,xh
  st -y,xl
  ret

